diff --git a/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java b/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java
index 99bd1665df66858634d4ba71eba2d4c82d9bffd0..5782f5303b479f4f3c42deb3e4c19768088dcb7d 100755
--- a/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java
+++ b/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java
@@ -36,10 +36,11 @@ import netscape.security.util.DerValue;
 import netscape.security.util.ObjectIdentifier;
 
 /**
- * <p>Abstract class for a revoked certificate in a CRL.
- * This class is for each entry in the <code>revokedCertificates</code>,
- * so it deals with the inner <em>SEQUENCE</em>.
- * The ASN.1 definition for this is:
+ * <p>
+ * Abstract class for a revoked certificate in a CRL. This class is for each
+ * entry in the <code>revokedCertificates</code>, so it deals with the inner
+ * <em>SEQUENCE</em>. The ASN.1 definition for this is:
+ * 
  * <pre>
  * revokedCertificates    SEQUENCE OF SEQUENCE  {
  *     userCertificate    CertificateSerialNumber,
@@ -47,11 +48,11 @@ import netscape.security.util.ObjectIdentifier;
  *     crlEntryExtensions Extensions OPTIONAL
  *                        -- if present, must be v2
  * }  OPTIONAL
- *
+ * 
  * CertificateSerialNumber  ::=  INTEGER
- *
+ * 
  * Extensions  ::=  SEQUENCE SIZE (1..MAX) OF Extension
- *
+ * 
  * Extension  ::=  SEQUENCE  {
  *     extnId        OBJECT IDENTIFIER,
  *     critical      BOOLEAN DEFAULT FALSE,
@@ -61,65 +62,70 @@ import netscape.security.util.ObjectIdentifier;
  *                   -- the extnId object identifier value
  * }
  * </pre>
- *
+ * 
  * @author Hemma Prafullchandra
  * @version 1.6 97/12/10
  */
 
-public class RevokedCertImpl extends RevokedCertificate
- implements Serializable{
+public class RevokedCertImpl extends RevokedCertificate implements Serializable{
 
     /**
      *
      */
-    private static final long serialVersionUID = -3449642360223397701L;
-    private SerialNumber serialNumber;
-    private Date revocationDate;
-    private CRLExtensions extensions = null;
-    private byte[] revokedCert;
-    private final static boolean isExplicit = false;
+        private static final long serialVersionUID = -3449642360223397701L;
+    
 
-    /**
-     * Default constructor.
-     */
-    public RevokedCertImpl() { }
+	private SerialNumber serialNumber;
+	private Date revocationDate;
+	private CRLExtensions extensions = null;
+	private byte[] revokedCert;
+	private final static boolean isExplicit = false;
 
-    /**
-     * Constructs a revoked certificate entry using the
-     * serial number and revocation date.
-     *
-     * @param num the serial number of the revoked certificate.
-     * @param date the Date on which revocation took place.
-     */
-    public RevokedCertImpl(BigInteger num, Date date) {
-        this.serialNumber = new SerialNumber(num);
-        this.revocationDate = date;
-    }
+	/**
+	 * Default constructor.
+	 */
+	public RevokedCertImpl() {
+	}
 
-    /**
-     * Constructs a revoked certificate entry using the
-     * serial number, revocation date and the entry
-     * extensions.
-     *
-     * @param num the serial number of the revoked certificate.
-     * @param date the Date on which revocation took place.
-     * @param crlEntryExts the extensions for this entry.
-     */
-    public RevokedCertImpl(BigInteger num, Date date,
-                           CRLExtensions crlEntryExts) {
-        this.serialNumber = new SerialNumber(num);
-        this.revocationDate = date;
-        this.extensions = crlEntryExts;
-    }
+	/**
+	 * Constructs a revoked certificate entry using the serial number and
+	 * revocation date.
+	 * 
+	 * @param num
+	 *            the serial number of the revoked certificate.
+	 * @param date
+	 *            the Date on which revocation took place.
+	 */
+	public RevokedCertImpl(BigInteger num, Date date) {
+		this.serialNumber = new SerialNumber(num);
+		this.revocationDate = date;
+	}
+
+	/**
+	 * Constructs a revoked certificate entry using the serial number,
+	 * revocation date and the entry extensions.
+	 * 
+	 * @param num
+	 *            the serial number of the revoked certificate.
+	 * @param date
+	 *            the Date on which revocation took place.
+	 * @param crlEntryExts
+	 *            the extensions for this entry.
+	 */
+	public RevokedCertImpl(BigInteger num, Date date, CRLExtensions crlEntryExts) {
+		this.serialNumber = new SerialNumber(num);
+		this.revocationDate = date;
+		this.extensions = crlEntryExts;
+	}
 
 	public byte[] getEncoded() throws CRLException {
 		// XXX NOT IMPLEMENTED
 		if (revokedCert == null) {
-    			DerOutputStream os = new DerOutputStream();
+			DerOutputStream os = new DerOutputStream();
 			try {
 				encode(os);
 			} catch (Exception e) {
-				//	revokedCert = null;
+				// revokedCert = null;
 			}
 			revokedCert = os.toByteArray();
 		}
@@ -131,316 +137,326 @@ public class RevokedCertImpl extends RevokedCertificate
 		return true;
 	}
 
-    /**
-     * Sets extensions for this impl.
-     *
-     * @param crlEntryExts CRLExtensions
-     */
-    public void setExtensions(CRLExtensions crlEntryExts) {
-        this.extensions = crlEntryExts;
-    }
+	/**
+	 * Sets extensions for this impl.
+	 * 
+	 * @param crlEntryExts
+	 *            CRLExtensions
+	 */
+	public void setExtensions(CRLExtensions crlEntryExts) {
+		this.extensions = crlEntryExts;
+	}
 
-    /**
-     * Unmarshals a revoked certificate from its encoded form.
-     *
-     * @param revokedCert the encoded bytes.
-     * @exception CRLException on parsing errors.
-     * @exception X509ExtensionException on extension handling errors.
-     */
-    public RevokedCertImpl(byte[] revokedCert)
-    throws CRLException, X509ExtensionException {
-        try {
-            DerValue derValue = new DerValue(revokedCert);
-            parse(derValue);
-        } catch (IOException e) {
-            throw new CRLException("Parsing error: " + e.toString());
-        }
-    }
+	/**
+	 * Unmarshals a revoked certificate from its encoded form.
+	 * 
+	 * @param revokedCert
+	 *            the encoded bytes.
+	 * @exception CRLException
+	 *                on parsing errors.
+	 * @exception X509ExtensionException
+	 *                on extension handling errors.
+	 */
+	public RevokedCertImpl(byte[] revokedCert) throws CRLException,
+			X509ExtensionException {
+		try {
+			DerValue derValue = new DerValue(revokedCert);
+			parse(derValue);
+		} catch (IOException e) {
+			throw new CRLException("Parsing error: " + e.toString());
+		}
+	}
 
-    /**
-     * Unmarshals a revoked certificate from its encoded form.
-     *
-     * @param derValue the DER value containing the revoked certificate.
-     * @exception CRLException on parsing errors.
-     * @exception X509ExtensionException on extension handling errors.
-     */
-    public RevokedCertImpl(DerValue derValue)
-    throws CRLException, X509ExtensionException {
-        parse(derValue);
-    }
+	/**
+	 * Unmarshals a revoked certificate from its encoded form.
+	 * 
+	 * @param derValue
+	 *            the DER value containing the revoked certificate.
+	 * @exception CRLException
+	 *                on parsing errors.
+	 * @exception X509ExtensionException
+	 *                on extension handling errors.
+	 */
+	public RevokedCertImpl(DerValue derValue) throws CRLException,
+			X509ExtensionException {
+		parse(derValue);
+	}
 
-    /**
-     * Returns true if this revoked certificate entry has
-     * extensions, otherwise false.
-     *
-     * @return true if this CRL entry has extensions, otherwise
-     * false.
-     */
-    public boolean hasExtensions() {
-        if (extensions == null)
-            return false;
-        else
-            return true;
-    }
+	/**
+	 * Returns true if this revoked certificate entry has extensions, otherwise
+	 * false.
+	 * 
+	 * @return true if this CRL entry has extensions, otherwise false.
+	 */
+	public boolean hasExtensions() {
+		if (extensions == null)
+			return false;
+		else
+			return true;
+	}
 
-    /**
-     * Decode a revoked certificate from an input stream.
-     *
-     * @param inStrm an input stream holding at least one revoked
-     * certificate
-     * @exception CRLException on parsing errors.
-     * @exception X509ExtensionException on extension handling errors.
-     */
-    public void decode(InputStream inStrm)
-    throws CRLException, X509ExtensionException {
-        try {
-            DerValue derValue = new DerValue(inStrm);
-            parse(derValue);
-        } catch (IOException e) {
-            throw new CRLException("Parsing error: " + e.toString());
-        }
-    }
+	/**
+	 * Decode a revoked certificate from an input stream.
+	 * 
+	 * @param inStrm
+	 *            an input stream holding at least one revoked certificate
+	 * @exception CRLException
+	 *                on parsing errors.
+	 * @exception X509ExtensionException
+	 *                on extension handling errors.
+	 */
+	public void decode(InputStream inStrm) throws CRLException,
+			X509ExtensionException {
+		try {
+			DerValue derValue = new DerValue(inStrm);
+			parse(derValue);
+		} catch (IOException e) {
+			throw new CRLException("Parsing error: " + e.toString());
+		}
+	}
 
-    /**
-     * Encodes the revoked certificate to an output stream.
-     *
-     * @param outStrm an output stream to which the encoded revoked
-     * certificate is written.
-     * @exception CRLException on encoding errors.
-     * @exception X509ExtensionException on extension handling errors.
-     */
-    public void encode(DerOutputStream outStrm)
-    throws CRLException, X509ExtensionException {
-        try {
-            if (revokedCert == null) {
-                DerOutputStream tmp = new DerOutputStream();
-                // sequence { serialNumber, revocationDate, extensions }
-                serialNumber.encode(tmp);
+	/**
+	 * Encodes the revoked certificate to an output stream.
+	 * 
+	 * @param outStrm
+	 *            an output stream to which the encoded revoked certificate is
+	 *            written.
+	 * @exception CRLException
+	 *                on encoding errors.
+	 * @exception X509ExtensionException
+	 *                on extension handling errors.
+	 */
+	public void encode(DerOutputStream outStrm) throws CRLException,
+			X509ExtensionException {
+		try {
+			if (revokedCert == null) {
+				DerOutputStream tmp = new DerOutputStream();
+				// sequence { serialNumber, revocationDate, extensions }
+				serialNumber.encode(tmp);
 
-                // from 2050 should encode GeneralizedTime
-                tmp.putUTCTime(revocationDate);
+				// from 2050 should encode GeneralizedTime
+				tmp.putUTCTime(revocationDate);
 
-                if (extensions != null)
-                    extensions.encode(tmp, isExplicit);
+				if (extensions != null)
+					extensions.encode(tmp, isExplicit);
 
-                DerOutputStream seq = new DerOutputStream();
-                seq.write(DerValue.tag_Sequence, tmp);
+				DerOutputStream seq = new DerOutputStream();
+				seq.write(DerValue.tag_Sequence, tmp);
 
-                revokedCert = seq.toByteArray();
-            }
-            outStrm.write(revokedCert);
-        } catch (IOException e) {
-             throw new CRLException("Encoding error: " + e.toString());
-        }
-    }
+				revokedCert = seq.toByteArray();
+			}
+			outStrm.write(revokedCert);
+		} catch (IOException e) {
+			throw new CRLException("Encoding error: " + e.toString());
+		}
+	}
 
-    /**
-     * Gets the serial number for this RevokedCertificate,
-     * the <em>userCertificate</em>.
-     *
-     * @return the serial number.
-     */
-    public BigInteger getSerialNumber() {
-        return ((BigInt)serialNumber.getNumber()).toBigInteger();
-    }
+	/**
+	 * Gets the serial number for this RevokedCertificate, the
+	 * <em>userCertificate</em>.
+	 * 
+	 * @return the serial number.
+	 */
+	public BigInteger getSerialNumber() {
+		return ((BigInt) serialNumber.getNumber()).toBigInteger();
+	}
 
-    /**
-     * Gets the revocation date for this RevokedCertificate,
-     * the <em>revocationDate</em>.
-     *
-     * @return the revocation date.
-     */
-    public Date getRevocationDate() {
-        return (new Date(revocationDate.getTime()));
-    }
+	/**
+	 * Gets the revocation date for this RevokedCertificate, the
+	 * <em>revocationDate</em>.
+	 * 
+	 * @return the revocation date.
+	 */
+	public Date getRevocationDate() {
+		return (new Date(revocationDate.getTime()));
+	}
 
-    /**
-     * Returns extensions for this impl.
-     *
-     * @return the CRLExtensions
-     */
-    public CRLExtensions getExtensions() {
-        return extensions;
-    }
+	/**
+	 * Returns extensions for this impl.
+	 * 
+	 * @return the CRLExtensions
+	 */
+	public CRLExtensions getExtensions() {
+		return extensions;
+	}
 
+	/**
+	 * Returns a printable string of this revoked certificate.
+	 * 
+	 * @return value of this revoked certificate in a printable form.
+	 */
+	public String toString() {
+		StringBuffer sb = new StringBuffer();
 
-    /**
-     * Returns a printable string of this revoked certificate.
-     *
-     * @return value of this revoked certificate in a printable form.
-     */
-    public String toString() {
-        StringBuffer sb = new StringBuffer();
+		sb.append(serialNumber.toString());
+		sb.append("  On: " + revocationDate.toString());
+		if (extensions != null) {
+			sb.append("\n");
+			for (int i = 0; i < extensions.size(); i++)
+				sb.append("Entry Extension[" + i + "]: "
+						+ ((Extension) (extensions.elementAt(i))).toString());
+		}
+		sb.append("\n");
+		return (sb.toString());
+	}
 
-        sb.append(serialNumber.toString());
-        sb.append("  On: " + revocationDate.toString());
-        if (extensions != null) {
-            sb.append("\n");
-            for (int i = 0; i < extensions.size(); i++)
-                sb.append("Entry Extension[" + i + "]: " +
-                     ((Extension)(extensions.elementAt(i))).toString());
-        }
-        sb.append("\n");
-        return (sb.toString());
-    }
+	/**
+	 * Gets a Set of the extension(s) marked CRITICAL in the RevokedCertificate
+	 * by OID strings.
+	 * 
+	 * @return a set of the extension oid strings in the Object that are marked
+	 *         critical.
+	 */
+	public Set<String> getCriticalExtensionOIDs() {
+		if (extensions == null)
+			return null;
+		Set<String> extSet = new TreeSet<String>();
+		Extension ex;
+		for (Enumeration<Extension> e = extensions.getElements(); e
+				.hasMoreElements();) {
+			ex = (Extension) e.nextElement();
+			if (ex.isCritical())
+				extSet.add(((ObjectIdentifier) ex.getExtensionId()).toString());
+		}
+		return extSet;
+	}
 
-    /**
-     * Gets a Set of the extension(s) marked CRITICAL in the
-     * RevokedCertificate by OID strings.
-     *
-     * @return a set of the extension oid strings in the
-     * Object that are marked critical.
-     */
-    public Set getCriticalExtensionOIDs() {
-        if (extensions == null)
-            return null;
-        Set extSet = new TreeSet();
-        Extension ex;
-            for (Enumeration e = extensions.getElements();
-                                          e.hasMoreElements();) {
-            ex = (Extension)e.nextElement();
-                if (ex.isCritical())
-                extSet.add(((ObjectIdentifier)ex.getExtensionId()).toString());
-            }
-        return extSet;
-    }
+	/**
+	 * Gets a Set of the extension(s) marked NON-CRITICAL in the
+	 * RevokedCertificate by OID strings.
+	 * 
+	 * @return a set of the extension oid strings in the Object that are marked
+	 *         critical.
+	 */
+	public Set<String> getNonCriticalExtensionOIDs() {
+		if (extensions == null)
+			return null;
+		Set<String> extSet = new TreeSet<String>();
+		Extension ex;
+		for (Enumeration<Extension> e = extensions.getElements(); e
+				.hasMoreElements();) {
+			ex = (Extension) e.nextElement();
+			if (!ex.isCritical())
+				extSet.add(ex.getExtensionId().toString());
+		}
+		return extSet;
+	}
 
-    /**
-     * Gets a Set of the extension(s) marked NON-CRITICAL in the
-     * RevokedCertificate by OID strings.
-     *
-     * @return a set of the extension oid strings in the
-     * Object that are marked critical.
-     */
-    public Set getNonCriticalExtensionOIDs() {
-        if (extensions == null)
-            return null;
-        Set extSet = new TreeSet();
-        Extension ex;
-            for (Enumeration e = extensions.getElements();
-                                          e.hasMoreElements();) {
-            ex = (Extension)e.nextElement();
-                if ( ! ex.isCritical())
-                extSet.add(((ObjectIdentifier)ex.getExtensionId()).toString());
-            }
-        return extSet;
-    }
+	/**
+	 * Gets the DER encoded OCTET string for the extension value (
+	 * <em>extnValue</em>) identified by the passed in oid String. The
+	 * <code>oid</code> string is represented by a set of positive whole number
+	 * separated by ".", that means,<br>
+	 * &lt;positive whole number&gt;.&lt;positive whole number&gt;.&lt;positive
+	 * whole number&gt;.&lt;...&gt;
+	 * 
+	 * @param oid
+	 *            the Object Identifier value for the extension.
+	 * @return the DER encoded octet string of the extension value.
+	 */
+	public byte[] getExtensionValue(String oid) {
+		if (extensions == null)
+			return null;
+		try {
+			String extAlias = OIDMap.getName(new ObjectIdentifier(oid));
+			Extension crlExt = null;
 
-    /**
-     * Gets the DER encoded OCTET string for the extension value
-     * (<em>extnValue</em>) identified by the passed in oid String.
-     * The <code>oid</code> string is
-     * represented by a set of positive whole number separated
-     * by ".", that means,<br>
-     * &lt;positive whole number&gt;.&lt;positive whole number&gt;.&lt;positive
-     * whole number&gt;.&lt;...&gt;
-     *
-     * @param oid the Object Identifier value for the extension.
-     * @return the DER encoded octet string of the extension value.
-     */
-    public byte[] getExtensionValue(String oid) {
-        if (extensions == null)
-            return null;
-            try {
-                String extAlias = OIDMap.getName(new ObjectIdentifier(oid));
-            Extension crlExt = null;
+			if (extAlias == null) { // may be unknown
+				ObjectIdentifier findOID = new ObjectIdentifier(oid);
+				Extension ex = null;
+				ObjectIdentifier inCertOID;
+				for (Enumeration<Extension> e = extensions.getElements(); e
+						.hasMoreElements();) {
+					ex = (Extension) e.nextElement();
+					inCertOID = ex.getExtensionId();
+					if (inCertOID.equals(findOID)) {
+						crlExt = ex;
+						break;
+					}
+				}
+			} else
+				crlExt = extensions.get(extAlias);
+			if (crlExt == null)
+				return null;
+			byte[] extData = crlExt.getExtensionValue();
+			if (extData == null)
+				return null;
 
-            if (extAlias == null) { // may be unknown
-                ObjectIdentifier findOID = new ObjectIdentifier(oid);
-                Extension ex = null;
-                ObjectIdentifier inCertOID;
-                for (Enumeration e=extensions.getElements();
-                                                 e.hasMoreElements();) {
-                    ex = (Extension)e.nextElement();
-                    inCertOID = ex.getExtensionId();
-                    if (inCertOID.equals(findOID)) {
-                        crlExt = ex;
-                        break;
-                    }
-                }
-            } else
-                crlExt = extensions.get(extAlias);
-                if (crlExt == null)
-                return null;
-                byte[] extData = crlExt.getExtensionValue();
-            if (extData == null)
-                return null;
+			DerOutputStream out = new DerOutputStream();
+			out.putOctetString(extData);
+			return out.toByteArray();
+		} catch (Exception e) {
+			return null;
+		}
+	}
 
-                    DerOutputStream out = new DerOutputStream();
-                    out.putOctetString(extData);
-            return out.toByteArray();
-        } catch (Exception e) {
-            return null;
-            }
-    }
+	private void parse(DerValue derVal) throws CRLException,
+			X509ExtensionException {
 
-    private void parse(DerValue derVal)
-    throws CRLException, X509ExtensionException  {
+		if (derVal.tag != DerValue.tag_Sequence) {
+			throw new CRLException("Invalid encoded RevokedCertificate, "
+					+ "starting sequence tag missing.");
+		}
+		if (derVal.data.available() == 0)
+			throw new CRLException("No data encoded for RevokedCertificates");
 
-       if (derVal.tag != DerValue.tag_Sequence) {
-            throw new CRLException("Invalid encoded RevokedCertificate, " +
-                                  "starting sequence tag missing.");
-        }
-        if (derVal.data.available() == 0)
-            throw new CRLException("No data encoded for RevokedCertificates");
+		// serial number
+		try {
+			DerInputStream in = derVal.toDerInputStream();
+			DerValue val = in.getDerValue();
+			this.serialNumber = new SerialNumber(val);
+		} catch (IOException e) {
+			throw new CRLException("Parsing Serial Number error: "
+					+ e.toString());
+		}
 
-        // serial number
-        try {
-            DerInputStream in = derVal.toDerInputStream();
-            DerValue val = in.getDerValue();
-            this.serialNumber = new SerialNumber(val);
-        } catch (IOException e) {
-            throw new CRLException("Parsing Serial Number error: "
-                                   + e.toString());
-        }
+		// revocationDate
+		try {
+			int nextByte = derVal.data.peekByte();
+			if ((byte) nextByte == DerValue.tag_UtcTime) {
+				this.revocationDate = derVal.data.getUTCTime();
+			} else if ((byte) nextByte == DerValue.tag_GeneralizedTime) {
+				this.revocationDate = derVal.data.getGeneralizedTime();
+			} else {
+				throw new CRLException(
+						"Invalid encoding for RevokedCertificates");
+			}
+		} catch (IOException e) {
+			throw new CRLException("Parsing Revocation Date error: "
+					+ e.toString());
+		}
 
-        // revocationDate
-        try {
-            int nextByte = derVal.data.peekByte();
-            if ((byte)nextByte == DerValue.tag_UtcTime) {
-                this.revocationDate = derVal.data.getUTCTime();
-            } else if ((byte)nextByte == DerValue.tag_GeneralizedTime) {
-                this.revocationDate = derVal.data.getGeneralizedTime();
-            } else {
-                throw new CRLException("Invalid encoding for RevokedCertificates");
-            }
-        } catch (IOException e) {
-            throw new CRLException("Parsing Revocation Date error: "
-                                   + e.toString());
-        }
+		if (derVal.data.available() == 0)
+			return; // no extensions
 
-        if (derVal.data.available() == 0)
-            return;  // no extensions
+		// crlEntryExtensions
+		try {
+			this.extensions = new CRLExtensions(derVal.toDerInputStream());
+		} catch (IOException e) {
+			throw new CRLException("Parsing CRL Entry Extensions error: "
+					+ e.toString());
+		}
+	}
 
-        // crlEntryExtensions
-        try {
-            this.extensions = new CRLExtensions(derVal.toDerInputStream());
-        } catch (IOException e) {
-            throw new CRLException("Parsing CRL Entry Extensions error: "
-                                   + e.toString());
-        }
-    }
+	/**
+	 * Serialization write ... X.509 certificates serialize as themselves, and
+	 * they're parsed when they get read back. (Actually they serialize as some
+	 * type data from the serialization subsystem, then the cert data.)
+	 */
+	private synchronized void writeObject(ObjectOutputStream stream)
+			throws CRLException, X509ExtensionException, IOException {
+		DerOutputStream dos = new DerOutputStream();
+		encode(dos);
+		dos.derEncode(stream);
+	}
 
-    /**
-     * Serialization write ... X.509 certificates serialize as
-     * themselves, and they're parsed when they get read back.
-     * (Actually they serialize as some type data from the
-     * serialization subsystem, then the cert data.)
-     */
-    private synchronized void writeObject(ObjectOutputStream stream)
-    throws CRLException, X509ExtensionException, IOException {
-        DerOutputStream dos = new DerOutputStream();
-        encode(dos);
-        dos.derEncode(stream);
-    }
-
-    /**
-     * Serialization read ... X.509 certificates serialize as
-     * themselves, and they're parsed when they get read back.
-     */
-    private synchronized void readObject(ObjectInputStream stream)
-    throws CRLException, X509ExtensionException, IOException {
-        decode(stream);
-    }
+	/**
+	 * Serialization read ... X.509 certificates serialize as themselves, and
+	 * they're parsed when they get read back.
+	 */
+	private synchronized void readObject(ObjectInputStream stream)
+			throws CRLException, X509ExtensionException, IOException {
+		decode(stream);
+	}
 
 }
diff --git a/pki/base/util/src/netscape/security/x509/RevokedCertificate.java b/pki/base/util/src/netscape/security/x509/RevokedCertificate.java
index 41f18d9b4bb0cc7a2569319e2a6b10d30c64e7ea..7db553ade5ca2b364e432835b22f13464df147b2 100644
--- a/pki/base/util/src/netscape/security/x509/RevokedCertificate.java
+++ b/pki/base/util/src/netscape/security/x509/RevokedCertificate.java
@@ -82,10 +82,15 @@ public abstract class RevokedCertificate extends X509CRLEntry {
      */
     public abstract boolean hasExtensions();
 
+    
+    
     /**
      * Returns a string representation of this revoked certificate.
      *
      * @return a string representation of this revoked certificate.
      */
     public abstract String toString();
+    
+    public abstract CRLExtensions getExtensions();
+
 }
diff --git a/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java b/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java
index 5c3ad35e9db8a3169fb6965ca9e30c5f0c182e8d..53f4eadb44d8efbfc2d83a96e17dfff9134ab0ff 100644
--- a/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java
+++ b/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java
@@ -64,7 +64,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "SubjectAlternativeName";
     public static final String SUBJECT_NAME = "subject_name";
 
     // private data members
@@ -222,17 +221,11 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(SUBJECT_NAME);
 
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
diff --git a/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java b/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
index da9170f3fa3c821ea63ba449bf4722987bb86537..134f0435ea7c41689e1aac05e2b03913a16f68e0 100644
--- a/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
+++ b/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
@@ -74,10 +74,9 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "SubjectDirectoryAttributes";
 
     // Private data members
-    private Vector attrList = new Vector();
+    private Vector<Attribute> attrList = new Vector<Attribute>();
 
     // Encode this extension value
     private void encodeThis() throws IOException {
@@ -85,9 +84,9 @@ implements CertAttrSet {
         DerOutputStream tmp = new DerOutputStream();
 
 		//encoding the attributes
-		Enumeration attrs = attrList.elements();
+		Enumeration<Attribute> attrs = attrList.elements();
 		while (attrs.hasMoreElements()) {
-            Attribute attr = (Attribute) attrs.nextElement();
+            Attribute attr =  attrs.nextElement();
 		    attr.encode(tmp);
 		}
 
@@ -104,7 +103,7 @@ implements CertAttrSet {
         }
 
         if (derVal.data.available() == 0) {
-            throw new IOException(NAME+" No data available in "
+            throw new IOException(this.getClass().getSimpleName()+" No data available in "
                                    + "passed DER encoded value.");
         }
 
@@ -161,7 +160,7 @@ implements CertAttrSet {
         this.critical = crit.booleanValue();
 
         if (!(value instanceof byte[]))
-            throw new IOException(NAME+"Illegal argument type");
+            throw new IOException(this.getClass().getSimpleName()+"Illegal argument type");
         int len = Array.getLength(value);
         byte[] extValue = new byte[len];
         System.arraycopy(value, 0, extValue, 0, len);
@@ -199,9 +198,9 @@ implements CertAttrSet {
     public String toString() {
         String s = super.toString() + "SubjectDirectoryAttributes:[\n";
 
-	Enumeration attrs = attrList.elements();
+	Enumeration<Attribute> attrs = attrList.elements();
 	while (attrs.hasMoreElements()) {
-	    Attribute attr = (Attribute) attrs.nextElement();
+	    Attribute attr = attrs.nextElement();
 	    s += attr.toString();
 	}
 
@@ -263,22 +262,16 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName() {
-        return (NAME);
-    }
 
     /**
      * Returns an enumeration of attributes in the extension.
      */
-    public Enumeration getAttributesList() {
+    public Enumeration<Attribute> getAttributesList() {
 	if (attrList == null) 
 		return null;
 	return attrList.elements();
diff --git a/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java b/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java
index fc65ec31ea4dddc9e439643fd51b444e25878a79..cbaf2ce5237ad26ee87f407db5ee92c4cfe6f0c8 100644
--- a/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java
+++ b/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java
@@ -64,7 +64,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "SubjectKeyIdentifier";
     public static final String KEY_ID = "key_id";
 
     // Private data member
@@ -203,17 +202,11 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(KEY_ID);
 
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
